; Elem v1.0 * Kaid * 01/1999
 
.INCLUDE CRASH82.INC

CrAshTitle:
.DB "Elem v1.0",0

SIZE = 2                        

Start:
        CALL CLEARLCD           ;Clear the screen

        SET 3,(IY+$05)          ;Invert video mode

        LD HL,CrAshTitle        ;Display the "title"
        ROM_CALL(D_ZT_STR)
        LD HL,Title
        ROM_CALL(D_ZT_STR)

        RES 3,(IY+$05)          ;Restore normal video mode

        LD HL,$2020             ;Clear the read buffer
        LD (Saisie),HL

        LD D,0                  ;D=0 (Row)        
        LD HL,Lin_Titles
        CALL Show_Infos         ;Displays titles of lines

        LD DE,Saisie            ;DE points to the read buffer

GetChar:
        LD HL,$0002             ;Show the buffer
        LD (CURSOR_POS),HL
        LD HL,Ch_Sai
        ROM_CALL(D_ZT_STR)

KeyPressed:

        PUSH DE                 
        CALL CR_KHAND           ;Wait for keypress
        POP DE

        CP K_ENTER              ;[ENTER] was pressed ?
        JR Z,Find               ; We start searching

        CP K_DEL                ;[DEL] was pressed ?
        JR Z,Delete             ; We delete one character

        LD HL,Keys              ;HL points to keys' table
        LD C,28                 ;Number of keys in the list

        CPIR                    ;Search A in (HL)

        LD A,C                  ;A=C (Position of the key in the list)

        OR A                    ;A=0 ?
        JR Z,KeyPressed         ;Key is unknown 

        ADD A,63                ;Number to letter


        LD HL,Saisie+SIZE       ;HL points to the second character of read buffer

        CALL CP_HL_DE           ;Compares DE (Offset of read buffer) and HL 
        JR Z,GetChar            ;If DE=HL, two characters were read.
        
        LD (DE),A               ;Put the character in the read buffer
        INC DE                  ;Points to next character
        JP GetChar         

Delete:

        LD HL,Saisie            ;Offset of start of read buffer

        CALL CP_HL_DE           ;Compares DE (Offset of read buffer) and HL 
        JR Z,GetChar            ;If DE=HL, the read buffer is void.

        DEC DE                  ;Points to previous character
        LD A,32                 
        LD (DE),A               ;Remplaces the character by a "space"
        JP GetChar


Find:

        LD DE,(Saisie)          ;The symbol is now in DE

        LD HL,$2020
        CALL CP_HL_DE           ;Is the read buffer void ?
        JR Z,End                ;Yes, we quit the program


        LD BC,Data              ;BC points to data

Find_Symbol:
        PUSH BC                 
        POP HL                  ;HL=Offset in data

        CALL LD_HL_MHL          ;HL=(HL)

        CALL CP_HL_DE           ;Compares DE (read buffer) and HL 
        JR Z,Found              ;if DE=HL, the element is found

        PUSH DE                 
        LD DE,$1234             ;Stop value
        CALL CP_HL_DE           ;Compares DE (read buffer) and HL 
        POP DE
        JR NZ,FindNext          ;If DE!=HL, data aren't finish

        JP Start                ;Go to start of program

FindNext:
        INC BC                  ;Incrementes pointer of data
        JP Find_Symbol 

Found:

        PUSH BC
        POP HL                  ;HL=Offset of corresponding line
        INC HL
        INC HL
        LD A,(HL)               ;A=Atomic number + 100
        INC HL                  

        LD D,5                  ;D=5 (Row)        
        CALL Show_Infos         ;Displays the element's informations

        SUB 100                 ;Adjust atomic number
        LD H,0
        LD L,A

        INC DE                  ;Go to last line
        LD (CURSOR_POS),DE

        ROM_CALL(D_HL_DECI)     ;Shows the atomic number

        CALL CR_KHAND
        JP Start

End:
        RET                     ;Bye ...


Show_Infos:
        LD B,2
        LD E,4                  ;First line

Show_Line:
        LD (CURSOR_POS),DE
        ROM_CALL(D_ZT_STR)      

        INC DE                  ;Incrementes line number

        DJNZ Show_Line          ;While B!=0 go to 'Show_Line'
        RET


Keys    .DB K_2
        .DB K_1
        .DB K_STO
        .DB K_MINUS
        .DB K_6
        .DB K_5
        .DB K_4
        .DB K_LN
        .DB K_TIMES
        .DB K_9
        .DB K_8
        .DB K_7
        .DB K_LOG
        .DB K_DIV
        .DB K_RPAREN
        .DB K_LPAREN
        .DB K_COMMA
        .DB K_SQR
        .DB K_POWER
        .DB K_TAN
        .DB K_COS
        .DB K_SIN
        .DB K_INVERSE
        .DB K_PRGM
        .DB K_MATRIX
        .DB K_MATH
        .DB K_DEL

Lin_Titles .DB "Name:",0
           .DB "Mass:",0

Ch_Sai  .DB "Symbol:"
Saisie  .DB 32,32,0

Title   .DB " * Kaid",0

.INCLUDE Elem_E.dat
