; Elem v1.0 * Kaid * 01/1999
 
.INCLUDE CRASH82.INC

TitreCrAsh:
.DB "Elem v1.0",0

TAILLE = 2                      ;Caractres  saisir
EA     = 150                    ;Code ASCII de "E accent aigu"
EG     = 151                    ;Code ASCII de "E accent grave"

Debut:
        CALL CLEARLCD           ;Efface l'cran texte

        SET 3,(IY+$05)          ;Inverse le mode vido

        LD HL,TitreCrAsh        ;Affiche la barre de titre
        ROM_CALL(D_ZT_STR)
        LD HL,Titre
        ROM_CALL(D_ZT_STR)

        RES 3,(IY+$05)          ;Mode vido normal

        LD HL,$2020             ;Vide le buffer de saisie
        LD (Saisie),HL

        LD D,0                  ;D=0 (Colonne)        
        LD HL,Legende
        CALL Aff_Infos          ;Affiche la lgende

        LD DE,Saisie            ;DE pointe sur le buffer de saisie

SaisieCar:
        LD HL,$0002             ;Affiche le buffer
        LD (CURSOR_POS),HL
        LD HL,Ch_Sai
        ROM_CALL(D_ZT_STR)

Pres_Touche:

        PUSH DE                 
        CALL CR_KHAND           ;Attend la pression d'une touche
        POP DE

        CP K_ENTER              ;[ENTER] presse ?
        JR Z,Recherche          ; On lance la recherche

        CP K_DEL                ;[DEL] presse ?
        JR Z,Efface             ; On efface un caractre

        LD HL,Touches           ;HL pointe sur le code des touches
        LD C,28                 ;Nombre de touches dans la liste

        CPIR                    ;Recherche A dans (HL)

        LD A,C                  ;A=C (Position de la touche dans la liste)

        OR A                    ;A=0 ?
        JR Z,Pres_Touche        ;La touche est inconnue

        ADD A,63                ;Transforme les codes des touches en lettres


        LD HL,Saisie+TAILLE     ;HL pointe sur le second caractre saisie         

        CALL CP_HL_DE           ;Compare DE (Offset de la saisie) et HL 
        JR Z,SaisieCar          ;S'ils sont gaux, la saisie est complte
        
        LD (DE),A               ;Place le caractre dans la chaine de saisie
        INC DE                  ;Pointe sur le caractre suivant
        JP SaisieCar          

Efface:

        LD HL,Saisie            ;Offset du dbut de chaine

        CALL CP_HL_DE           ;Compare DE (Offset de la saisie) et HL 
        JR Z,SaisieCar          ;S'ils sont gaux, il n'y a pas de saisie

        DEC DE                  ;Pointe sur le caractre prcdent
        LD A,32                 
        LD (DE),A               ;Remplace le caractre par un espace dans la saisie
        JP SaisieCar


Recherche:

        LD DE,(Saisie)          ;DE contient le symbole

        LD HL,$2020
        CALL CP_HL_DE           ;Test si la saisie est nulle
        JR Z,Quitte             ;Si oui, on quitte le programme


        LD BC,Donnees           ;BC pointe sur les donnes

Rech_Symbole:
        PUSH BC                 
        POP HL                  ;HL=Offset dans la base

        CALL LD_HL_MHL          ;HL=(HL)

        CALL CP_HL_DE           ;Compare DE (Saisie) et HL 
        JR Z,Trouve             ;S'ils sont gaux, l'lment est trouv

        PUSH DE                 
        LD DE,$1234             ;DE contient la valeur de fin
        CALL CP_HL_DE           ;Compare DE (Saisie) et HL 
        POP DE
        JR NZ,Trouve_Proch      ;S'ils sont diffrents, la liste n'est pas finie

        JP Debut                ;Retourne au dbut du programme

Trouve_Proch:
        INC BC                  ;Incrmente le pointeur de donnes
        JP Rech_Symbole 

Trouve:

        PUSH BC
        POP HL                  ;HL=Offset de la ligne correspondante
        INC HL
        INC HL
        LD A,(HL)               ;A=Numro Atomique + 100
        INC HL                  ;Pointe 3 octets aprs, sur le nom de l'lment

        LD D,4                  ;D=4 (Colonne)        
        CALL Aff_Infos          ;Affiche la lgende

        SUB 100                 ;Ajuste le numro atomique
        LD H,0
        LD L,A

        INC DE                  ;Affiche sur la dernire ligne
        LD (CURSOR_POS),DE

        ROM_CALL(D_HL_DECI)     ;Affiche le numro sur 16 bits (merde!)

        CALL CR_KHAND
        JP Debut

Quitte:
        RET                     ;On quitte


Aff_Infos:
        LD B,2
        LD E,4                  ;Ligne de dpart

Aff_Lgn:
        LD (CURSOR_POS),DE
        ROM_CALL(D_ZT_STR)      ;Affiche la chaine pointe par HL

        INC DE                  ;Incrmente la ligne

        DJNZ Aff_Lgn            ;Boucle tant que B!=0
        RET


Touches .DB K_2
        .DB K_1
        .DB K_STO
        .DB K_MINUS
        .DB K_6
        .DB K_5
        .DB K_4
        .DB K_LN
        .DB K_TIMES
        .DB K_9
        .DB K_8
        .DB K_7
        .DB K_LOG
        .DB K_DIV
        .DB K_RPAREN
        .DB K_LPAREN
        .DB K_COMMA
        .DB K_SQR
        .DB K_POWER
        .DB K_TAN
        .DB K_COS
        .DB K_SIN
        .DB K_INVERSE
        .DB K_PRGM
        .DB K_MATRIX
        .DB K_MATH
        .DB K_DEL

Legende .DB "Nom:",0
        .DB "Mol:",0

Ch_Sai  .DB "Symbole:"
Saisie  .DB 32,32,0

Titre   .DB " * Kaid",0

.INCLUDE Elem_F.dat
